#include <iostream>
#include <Fl/Fl.H>
#include <Fl/Fl_Box.H>
#include <Fl/Fl_Export.H>
#include <FL/Fl_Window.H>
#include <FL/fl_draw.H>
#include "vkvm.hpp"
#include "internal.hpp"

#ifndef GUI_GUI_HPP
#define GUI_GUI_HPP

/** GUI_Window
 * The GUI_Window-class generates a window, within the window it recognizes the curretn mouse-position.
 * It also recognizes if a button is pushed on the keyboard or the mouse. Furthermore the class depict the
 * content of the Image-class and provides functions to refresh it.
 * @param x The mouse-position on the x-axis.
 * @param y The mouse-position on the y-axis.
 * @param button The button that was pushed last.
 */
class GUI_Window : public Fl_Window {
    int x, y, button;
    vkvm::KeyCode keyCode;
    int handle(int e);
    char* position_to_string(int x,int y);
public:
    GUI_Window(int x, int y, const char *l);
};

/** The constructor of the image class, get additional
  * @param x: The mouse-position on the x-axis.
  * @param y: The mouse-position on the y-axis:
  * @param w: The width of a single pixel,
  * @param h: The height of a single pixel.
  */

class Image : public Fl_Widget {
    uchar *buf;
public:
    Image(int x, int y, int w, int h);

    void draw();

    void getPixels();
};

/** Statusbar
 *  The class inherits a char *text from the Fl_Box. It also shows the window-resolution and the mouse-position.
 *  @param text: A pointer to a char-array, that can contain a text like a status or whatever you want.
 */
class Statusbar : public Fl_Box {
    char *text;
public:
    Statusbar(int x, int y, int w, int h, char *text);
};

char* get_resolusion(int window_height, int window_width);
void refresh_image(void *pointer);
void get_new_image(void *pointer) ;
int GUI_run(int argc, char **argv);

#endif //GUI_GUI_HPP
