#include "GUI.hpp"


/*Function to handle the input*/
auto GUI_Window::handle(int e) -> int {
    switch (e) {
        /*Mousebutton*/
        case FL_PUSH:
            if (Fl::event_button() == FL_LEFT_MOUSE) {
                std::cout << "Mouse:left" << std::endl;
            } else if (Fl::event_button() == FL_RIGHT_MOUSE) {
                std::cout << "Mouse:right" << std::endl;
            } else {
                std::cout << "Mouse:middle" << std::endl;
            }
            this->child(2)->label("Event:Mouse Button");
            vkvm::callEvent(vkvm::EventType::MouseButton);
            return 1;
            /*Mousebutton and movement*/
        case FL_DRAG:
            x = Fl::event_x();
            y = Fl::event_y();
            vkvm::setMousePosition(x,y);
            if (Fl::event_button() == FL_LEFT_MOUSE) {
                std::cout << "Mouse:left" << std::endl;
            } else if (Fl::event_button() == FL_RIGHT_MOUSE) {
                std::cout << "Mouse:right" << std::endl;
            } else {
                std::cout << "Mouse:middle" << std::endl;
            }
            this->child(2)->label("Event:Mouse Drag");
            this->child(3)->label(position_to_string(x,y));
            vkvm::callEvent(vkvm::EventType::MouseButton);
            vkvm::callEvent(vkvm::EventType::MouseMove);
            return 1;
            /*Mousemovement*/
        case FL_MOVE:
            x = Fl::event_x();
            y = Fl::event_y();
            vkvm::setMousePosition(x,y);
            vkvm::callEvent(vkvm::EventType::MouseMove);
            this->child(2)->label("Event:Mouse Move");
            this->child(3)->label(position_to_string(x,y));
            return 1;
            /*keyboardbutton*/
        case FL_KEYBOARD:
            button = Fl::event_button();
            keyCode = vkvm::KeyCode(button);
            vkvm::buttonPressed(keyCode);
            vkvm::callEvent(vkvm::EventType::KeyDown);
            this->child(2)->label("Event:Key Down");
            return 1;
        case FL_KEYUP:
            button = Fl::event_button();
            std::cout<<button<<std::endl;
            keyCode = vkvm::KeyCode(button);
            vkvm::buttonPressed(keyCode);
            vkvm::callEvent(vkvm::EventType::KeyUp);
            this->child(2)->label("Event:Key Up");
            return 1;
    }
    return -1;
}

GUI_Window::GUI_Window(int x, int y, const char *l) : Fl_Window(x, y, l) {}

auto GUI_Window::position_to_string(int x,int y)->char*{
    char *str = new char[25];
    std::string str_temp;
    str = strcpy(str,"Mouse Position X:");
    str_temp = std::to_string(x);
    str = strcat(str,str_temp.c_str());
    str = strcat(str," Y:");
    str_temp = std::to_string(y);
    str = strcat(str,str_temp.c_str());
    return str;
}


